package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.UserRoleDEField;
import com.sa.ibiz.demo.demo.domain.UserRole;

/**
 * 实体[UserRoleDEFields] 数据对象
 */
@TableName(value = "T_SRFUSERROLEDEFIELDS",resultMap = "UserRoleDEFieldsResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserRoleDEFields extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserRoleDEField userroledefield;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserRole userrole;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userroledefieldid;
    @TableField(exist = false)//逻辑属性
    private String userroledefieldname;
    @TableId(value= "userroledefieldsid",type=IdType.UUID)//指定主键生成策略
    private String userroledefieldsid;
    private String userroledefieldsname;
    private String userroleid;
    @TableField(exist = false)//逻辑属性
    private String userrolename;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[实体属性访问能力]
     *  @param userroledefieldid
     */
    public void setUserroledefieldid(String userroledefieldid){
        if(StringUtils.isEmpty(userroledefieldid))
            userroledefieldid=null;
        this.userroledefieldid = userroledefieldid;
        this.set("userroledefieldiddirtyflag",true);
    }
    /**
     *  获取属性值[实体属性访问能力]
     */
    public String getUserroledefieldid(){
        return this.userroledefieldid;
    }
    /**
     *  重置属性值[实体属性访问能力]
     */
    public void resetUserroledefieldid(){
        this.set("userroledefieldiddirtyflag",false);
        this.userroledefieldid = null;
    }
    /**
     *  设置属性值[实体属性控制]
     *  @param userroledefieldname
     */
    public void setUserroledefieldname(String userroledefieldname){
        if(StringUtils.isEmpty(userroledefieldname))
            userroledefieldname=null;
        this.userroledefieldname = userroledefieldname;
        this.set("userroledefieldnamedirtyflag",true);
    }
    /**
     *  获取属性值[实体属性控制]
     */
    public String getUserroledefieldname(){
        return this.userroledefieldname;
    }
    /**
     *  重置属性值[实体属性控制]
     */
    public void resetUserroledefieldname(){
        this.set("userroledefieldnamedirtyflag",false);
        this.userroledefieldname = null;
    }
    /**
     *  设置属性值[用户角色相关实体属性访问控制标识]
     *  @param userroledefieldsid
     */
    public void setUserroledefieldsid(String userroledefieldsid){
        if(StringUtils.isEmpty(userroledefieldsid))
            userroledefieldsid=null;
        this.userroledefieldsid = userroledefieldsid;
        this.set("userroledefieldsiddirtyflag",true);
    }
    /**
     *  获取属性值[用户角色相关实体属性访问控制标识]
     */
    public String getUserroledefieldsid(){
        return this.userroledefieldsid;
    }
    /**
     *  重置属性值[用户角色相关实体属性访问控制标识]
     */
    public void resetUserroledefieldsid(){
        this.set("userroledefieldsiddirtyflag",false);
        this.userroledefieldsid = null;
    }
    /**
     *  设置属性值[用户角色相关实体属性访问控制]
     *  @param userroledefieldsname
     */
    public void setUserroledefieldsname(String userroledefieldsname){
        if(StringUtils.isEmpty(userroledefieldsname))
            userroledefieldsname=null;
        this.userroledefieldsname = userroledefieldsname;
        this.set("userroledefieldsnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户角色相关实体属性访问控制]
     */
    public String getUserroledefieldsname(){
        return this.userroledefieldsname;
    }
    /**
     *  重置属性值[用户角色相关实体属性访问控制]
     */
    public void resetUserroledefieldsname(){
        this.set("userroledefieldsnamedirtyflag",false);
        this.userroledefieldsname = null;
    }
    /**
     *  设置属性值[用户角色]
     *  @param userroleid
     */
    public void setUserroleid(String userroleid){
        if(StringUtils.isEmpty(userroleid))
            userroleid=null;
        this.userroleid = userroleid;
        this.set("userroleiddirtyflag",true);
    }
    /**
     *  获取属性值[用户角色]
     */
    public String getUserroleid(){
        return this.userroleid;
    }
    /**
     *  重置属性值[用户角色]
     */
    public void resetUserroleid(){
        this.set("userroleiddirtyflag",false);
        this.userroleid = null;
    }
    /**
     *  设置属性值[用户角色]
     *  @param userrolename
     */
    public void setUserrolename(String userrolename){
        if(StringUtils.isEmpty(userrolename))
            userrolename=null;
        this.userrolename = userrolename;
        this.set("userrolenamedirtyflag",true);
    }
    /**
     *  获取属性值[用户角色]
     */
    public String getUserrolename(){
        return this.userrolename;
    }
    /**
     *  重置属性值[用户角色]
     */
    public void resetUserrolename(){
        this.set("userrolenamedirtyflag",false);
        this.userrolename = null;
    }
     /**
     *  获取主实体关联数据[UserRoleDEField]
     */
    public UserRoleDEField getUserroledefield() {
        return userroledefield;
    }
    /**
     *  设置主实体关联数据[UserRoleDEField]
     */
    public void setUserroledefield(UserRoleDEField userroledefield) {
        this.userroledefield = userroledefield;
    }

     /**
     *  获取主实体关联数据[UserRole]
     */
    public UserRole getUserrole() {
        return userrole;
    }
    /**
     *  设置主实体关联数据[UserRole]
     */
    public void setUserrole(UserRole userrole) {
        this.userrole = userrole;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetUserroledefieldid();
        resetUserroledefieldname();
        resetUserroledefieldsid();
        resetUserroledefieldsname();
        resetUserroleid();
        resetUserrolename();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
    	//联合主键
        String primaryKey ="";
        primaryKey+=this.getUserroleid();
        primaryKey+="||";
        primaryKey+=this.getUserroledefieldid();
        return  DigestUtils.md5DigestAsHex(primaryKey.getBytes());
    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserRoleDEFields copyTo(UserRoleDEFields targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserRoleDEFields.class, UserRoleDEFields.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserroledefieldsid();
		return targetEntity;
	}
}